#ifndef LIST_H
#define LIST_H

struct point
{
	int i;
	struct point *next;
};

struct list
{
	struct point *front;
	struct point *last;
};

void push_back(struct list *obj, struct point pt)
{
	if(obj->last == NULL)
	{
		obj->front = (struct point *) malloc(sizeof(struct point *));
		obj->front->i = pt.i;
		obj->last = obj->front;
	}
	else
	{
		obj->last->next = (struct point *) malloc(sizeof(struct point *));
		obj->last = obj->last->next;
		obj->last->i = pt.i;
	}
	obj->last->next = NULL;
}

int empty(struct list *obj)
{
	if(obj->front == NULL)
		return 1;
	return 0;
}

struct point *front(struct list *obj)
{
	return (obj->front);
}

struct point pop_front(struct list *obj)
{
	struct point temp = *(obj->front);
	struct point* tmp = obj->front;
	obj->front = obj->front->next;
	free(tmp);
	return temp;
}

void clear(struct list *obj)
{
	while (obj->front != NULL)
	{
		struct point *temp = obj->front;
		obj->front = obj->front->next;
		free(temp);
	}
	obj->last = NULL;
}

#endif